--- old/usr/src/common/zfs/zfeature_common.c	Mon Oct  7 19:17:12 2013
+++ new/usr/src/common/zfs/zfeature_common.c	Mon Oct  7 19:17:12 2013
@@ -167,4 +167,13 @@
 	zfeature_register(SPA_FEATURE_SPACEMAP_HISTOGRAM,
 	    "com.delphix:spacemap_histogram", "spacemap_histogram",
 	    "Spacemaps maintain space histograms.", B_TRUE, B_FALSE, NULL);
+	zfeature_register(SPA_FEATURE_SHA512,
+	    "org.illumos:sha512", "sha512",
+	    "SHA-512/256 truncated hash algorithm.", B_FALSE, B_FALSE, NULL);
+	zfeature_register(SPA_FEATURE_SKEIN,
+	    "org.illumos:skein", "skein",
+	    "Skein hash algorithm.", B_FALSE, B_FALSE, NULL);
+	zfeature_register(SPA_FEATURE_EDONR,
+	    "org.illumos:edonr", "edonr",
+	    "Edon-R hash algorithm.", B_FALSE, B_FALSE, NULL);
 }
